请设计一个函数,用来判断在一个n乘m的矩阵中是否存在一条包含某长度为len的字符串所有字符的路径。路径可以从矩阵中的任意一个格子开始,每一步可以在矩阵中向左,向右,向上,向下移动一个格子。如果一条路径经过了矩阵中的某一个格子,则该路径不能再进入该格子。 例如:
[a b c e]
[s f c s]
[a d e e]
矩阵中包含一条字符串"bcced"的路径,但是矩阵中不包含"abcb"路径,因为字符串的第一个字符b占据了矩阵中的第一行第二个格子之后,路径不能再次进入该格子。
采用回溯法思想,对于矩阵中各个坐标一个个尝试,并递归查找对应位置上下左右位置,直到查找完毕;
牛客链接以及题解
public boolean hasPath (char[][] matrix, String word) {
char[] words = word.toCharArray();
//遍历查找矩阵各个位置是否满足
for(int i = 0 ; i < matrix.length ; i++){
for(int j = 0; j < matrix[0].length;j++){
if(dfs(matrix,words,i,j,0)){
return true;
}
}
}
return false;
}
/**
* matrix 表示二维查找矩阵
* 目标字符串
* i 表示 行号
* j 表示 列号
* index 表示字符当前下标
*/
private boolean dfs(char[][] matrix,char[] words,int i,int j,int index){
//边界判断
if(i < 0 || i >= matrix.length || j < 0 || j >= matrix[0].length || words[index] != matrix[i][j]){
return false;
}
//匹配结束,直接返回true
if(index == words.length -1){
return true;
}
//记录下当前字符,用于后续还原
char temp = matrix[i][j];
//使用过的字符设置为特殊符号,标记为已使用,后续无法再次匹配成功
matrix[i][j] = '@';
//递归查找上下左右字符是否匹配成功
boolean res = dfs(matrix,words,i-1,j,index+1) || dfs(matrix,words,i+1,j,index+1) ||dfs(matrix,words,i,j-1,index+1) || dfs(matrix,words,i,j+1,index+1);
//还原字符,用于再次匹配
matrix[i][j] = temp;
return res;
}
地上有一个 rows 行和 cols 列的方格。坐标从 [0,0] 到 [rows-1,cols-1] 。一个机器人从坐标 [0,0] 的格子开始移动,每一次只能向左,右,上,下四个方向移动一格,但是不能进入行坐标和列坐标的数位之和大于 threshold 的格子。 例如,当 threshold 为 18 时,机器人能够进入方格 [35,37] ,因为 3+5+3+7 = 18。但是,它不能进入方格 [35,38] ,因为 3+5+3+8 = 19 。请问该机器人能够达到多少个格子?
牛客链接
同样是采用回溯法进行解题,我们只需要正确的处理边界判断逻辑,然后套用通用模板即可;
public int movingCount(int threshold, int rows, int cols) {
//用于记录当前下标是否被访问过
boolean[][] isVisited = new boolean[rows][cols];
//从 0,0下标开始访问
return dfs(threshold,isVisited,rows,cols,0,0);
}
private int dfs(int threshold,boolean[][] isVisited,int rows,int cols, int i,int j){
//处理访问边界
if(i<0 || i>=rows || j<0 || j>=cols){
return 0;
}
//访问过的 或者不满足threshold阈值的过滤掉
if(isVisited[i][j] || sum(i,j) > threshold){
return 0;
}
//标记已访问过
isVisited[i][j] = true;
//上下左右运动
return 1+ dfs(threshold,isVisited,rows,cols,i-1,j) + dfs(threshold,isVisited,rows,cols,i+1,j) + dfs(threshold,isVisited,rows,cols,i,j-1) + dfs(threshold,isVisited,rows,cols,i,j+1);
}